﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace exerciface
{
    class Programa
    {

        public interface IConta
        {
            void depositar(double valor);
            void sacar(double valor);
            double getSaldo();
        }

        public class ContaCorrente : IConta 
        {
            private double Saldo { get; set; }
            private double Tarifa { get; set; }


            public ContaCorrente()
            {
                Console.Write("Informe o valor inicial para o saldo: ");
                this.Saldo = Convert.ToDouble(Console.ReadLine());
                Console.Write("Informe o valor inicial para a tarifa de saque: ");
                this.Tarifa = Convert.ToDouble(Console.ReadLine());
            }

            public void depositar(double valor)
            {
                this.Saldo += valor;
                Console.WriteLine("O novo saldo é R$ {0}", this.Saldo);
            }

            public void sacar(double valor)
            {
                valor += this.Tarifa;
                if (this.Saldo - valor >= 0)
                    this.Saldo -= valor;
                else
                    Console.WriteLine("Saldo insuficiente para o saque.");
            }

            public double getSaldo()
            {
                return this.Saldo;
            }
        }

        public class ContaPoupanca : IConta
        {
            private double Saldo { get; set; }

            public ContaPoupanca()
            {
                Console.Write("Informe o valor inicial para o saldo: ");
                this.Saldo = Convert.ToDouble(Console.ReadLine());
            }

            public void depositar(double valor)
            {
                this.Saldo += valor;
                Console.WriteLine("O novo saldo é R$ {0}", this.Saldo);
            }

            public void sacar(double valor)
            {
                if (this.Saldo - valor >= 0)
                    this.Saldo -= valor;
                else
                    Console.WriteLine("Saldo insuficiente para o saque.");
            }

            public double getSaldo()
            {
                return this.Saldo;
            }

        }

        public  class GeradordeExtratos
        {

            public static void GerarExtrato(IConta c)
            {
                Console.WriteLine("O saldo da conta é R$ {0}",c.getSaldo());
            }
        }

        static void Main()
        {
            ContaCorrente cc = new ContaCorrente();
            double valor;
            Console.Write("Informe o valor a depositar: ");
            valor = Convert.ToDouble(Console.ReadLine());
            cc.depositar(valor);
            Console.Write("Informe o valor a sacar: ");
            valor = Convert.ToDouble(Console.ReadLine());
            cc.sacar(valor);
            Console.Write("Informe o valor a sacar: ");
            valor = Convert.ToDouble(Console.ReadLine());
            cc.sacar(valor);
            GeradordeExtratos.GerarExtrato(cc); 
            ContaPoupanca cp = new ContaPoupanca();
            Console.Write("Informe o valor a depositar: ");
            valor = Convert.ToDouble(Console.ReadLine());
            cp.depositar(valor);
            Console.Write("Informe o valor a sacar: ");
            valor = Convert.ToDouble(Console.ReadLine());
            cp.sacar(valor);
            Console.Write("Informe o valor a sacar: ");
            valor = Convert.ToDouble(Console.ReadLine());
            cp.sacar(valor);
            GeradordeExtratos.GerarExtrato(cp);
            
            Console.ReadKey();
        }
    }
}
